function Donnees=A_Donnees(NVar,Ordre);
Donnees=zeros((Ordre+1)^NVar,NVar);
if Ordre==2
    Standards=[-sqrt(3),0,sqrt(3)];
elseif Ordre==3
    Standards=[-sqrt(3+sqrt(6)),-sqrt(3-sqrt(6)),sqrt(3-sqrt(6)),sqrt(3+sqrt(6))];
elseif Ordre==4
    Standards=[-sqrt(5+sqrt(10)),-sqrt(5-sqrt(10)),0,sqrt(5-sqrt(10)),sqrt(5+sqrt(10))];
elseif Ordre==5
    Standards=[-3.324257,-1.889176,-0.616707,0.616707,1.889176,3.324357];
end
lignemax=size(Donnees,1);
for j=1:NVar
    NJ=(Ordre+1)^(NVar-j);
    i=1;
    ligne1=1;
    ligne2=NJ;
    NumStan=1;
    while ligne2<lignemax+1
        Donnees(ligne1:ligne2,j)=Standards(1,NumStan)*ones(ligne2-ligne1+1,1);
        ligne1=ligne1+NJ;
        ligne2=ligne2+NJ;
        NumStan=NumStan+1;
        if NumStan>Ordre+1
            NumStan=1;
        end
    end
end
if Ordre/2~=floor(Ordre/2)
    Donnees=cat(1,zeros(1,size(Donnees,2)),Donnees);
end