function [Sobol]=A_Indices_Sobol(F,Psis)
Npsi=size(Psis,1);
Nvar=size(Psis,2);
Sobol=zeros(2^Nvar-1,Nvar+1);
Nsobol=1;
for psi=2:Npsi
    OK=1;
    for var=1:Nvar
        if Psis(psi,var)>1
            OK=0;
        end
    end
    if OK==1
        Sobol(Nsobol,1:Nvar)=Psis(psi,:);
        Nsobol=Nsobol+1;
    end
end
Nsobol=2^Nvar-1;
for i=1:Nsobol
    if sum(Sobol(i,1:Nvar))==0
        Sobol(i,1:Nvar)=ones(1,Nvar);
    end
end
for i=1:Nsobol
    for psi=1:Npsi
        OK=1;
        for var=1:Nvar
            if (Psis(psi,var)==0 & Sobol(i,var)~=0) | (Psis(psi,var)~=0 & Sobol(i,var)==0)
                OK=0;
            end
        end
        if OK==1
            produit=1;
            for m=1:Nvar
                produit=produit*factorial(Psis(psi,m));
            end
            Sobol(i,Nvar+1)=Sobol(i,Nvar+1)+F(psi,1)^2*produit;
        end
    end
end
Variance=0;
for psi=2:Npsi
    produit=1;
    for m=1:Nvar
         produit=produit*factorial(Psis(psi,m));
    end
    Variance=Variance+F(psi,1)^2*produit;
end
Sobol(:,Nvar+1)=Sobol(:,Nvar+1)/Variance;
