Pow=zeros(size(Points,1)-1,5);
for j=1:j_A-1
    Wp=0;
    Wr=0;
    if j/2==round(j/2)
        depinf=Nteta/2-j/2;
        depsup=Nteta/2-j/2;
        fininf=Nteta/2+j/2-1;
        finsup=Nteta/2+j/2;
    else
        depinf=Nteta/2-(j-1)/2;
        depsup=Nteta/2-(j-1)/2-1;
        fininf=Nteta/2+(j+1)/2-1;
        finsup=Nteta/2+(j+1)/2-1;
    end
    for i=depinf:fininf
        if j/2==round(j/2)
            x1=Points(j,i,1);
            x2=Points(j,i+1,1);
            x3=Points(j+1,i+1,1);
            y1=Points(j,i,2);
            y2=Points(j,i+1,2);
            y3=Points(j+1,i+1,2);
            z1=Points(j,i,3);
            z2=Points(j,i+1,3);
            z3=Points(j+1,i+1,3);
        else
            x1=Points(j,i,1);
            x2=Points(j,i+1,1);
            x3=Points(j+1,i,1);
            y1=Points(j,i,2);
            y2=Points(j,i+1,2);
            y3=Points(j+1,i,2);
            z1=Points(j,i,3);
            z2=Points(j,i+1,3);
            z3=Points(j+1,i,3);
        end
        xc=(x1+x2+x3)/3;
        yc=(y1+y2+y3)/3;
        zc=(z1+z2+z3)/3;
        coh=B_Cohesion(xc,yc,zc);
        phi=B_Friction(xc,yc,zc);
        r=sqrt((Yo-yc)^2+(Zo-zc)^2);
        bet=atan(-(zc-Zo)/(yc-Yo));
        a=sqrt((y1-y2)^2+(z1-z2)^2);
        b=sqrt((y1-y3)^2+(z1-z3)^2);
        c=sqrt((y3-y2)^2+(z3-z2)^2);
        Wp=Wp+r*sin(bet)*B_Airetri(a,b,c)*abs(xc);
        a=sqrt((x1-x2)^2+(y1-y2)^2+(z1-z2)^2);
        b=sqrt((x1-x3)^2+(y1-y3)^2+(z1-z3)^2);
        c=sqrt((x3-x2)^2+(y3-y2)^2+(z3-z2)^2);
        Wr=Wr+cos(phi)*r*B_Airetri(a,b,c);
    end
    for i=depsup:finsup
        if j/2==round(j/2)
            x1=Points(j+1,i,1);
            x2=Points(j+1,i+1,1);
            x3=Points(j,i,1);
            y1=Points(j+1,i,2);
            y2=Points(j+1,i+1,2);
            y3=Points(j,i,2);
            z1=Points(j+1,i,3);
            z2=Points(j+1,i+1,3);
            z3=Points(j,i,3);
        else
            x1=Points(j+1,i,1);
            x2=Points(j+1,i+1,1);
            x3=Points(j,i+1,1);
            y1=Points(j+1,i,2);
            y2=Points(j+1,i+1,2);
            y3=Points(j,i+1,2);
            z1=Points(j+1,i,3);
            z2=Points(j+1,i+1,3);
            z3=Points(j,i+1,3);
        end
        xc=(x1+x2+x3)/3;
        yc=(y1+y2+y3)/3;
        zc=(z1+z2+z3)/3;
        coh=B_Cohesion(xc,yc,zc);
        phi=B_Friction(xc,yc,zc);
        r=sqrt((Yo-yc)^2+(Zo-zc)^2);
        bet=atan(-(zc-Zo)/(yc-Yo));
        a=sqrt((y1-y2)^2+(z1-z2)^2);
        b=sqrt((y1-y3)^2+(z1-z3)^2);
        c=sqrt((y3-y2)^2+(z3-z2)^2);
        Wp=Wp+r*sin(bet)*B_Airetri(a,b,c)*abs(xc);
        a=sqrt((x1-x2)^2+(y1-y2)^2+(z1-z2)^2);
        b=sqrt((x1-x3)^2+(y1-y3)^2+(z1-z3)^2);
        c=sqrt((x3-x2)^2+(y3-y2)^2+(z3-z2)^2);
        Wr=Wr+cos(phi)*r*B_Airetri(a,b,c);
    end
    Pow(j,1)=real(Wp);
    Pow(j,2)=real(Wr);
end
Points(j_A:size(Points,1),3*Nteta/4+1,:)=Points(j_A:size(Points,1),Nteta/4,:);
for j=j_A:size(Points,1)-1
    Wp=0;
    Wr=0;
    Wrt=0;
    dep=Nteta/4;
    fin=3*Nteta/4;
    for i=dep:fin
        if j/2==round(j/2)
            x1=Points(j,i,1);
            x2=Points(j,i+1,1);
            x3=Points(j+1,i+1,1);
            y1=Points(j,i,2);
            y2=Points(j,i+1,2);
            y3=Points(j+1,i+1,2);
            z1=Points(j,i,3);
            z2=Points(j,i+1,3);
            z3=Points(j+1,i+1,3);
        else
            x1=Points(j,i,1);
            x2=Points(j,i+1,1);
            x3=Points(j+1,i,1);
            y1=Points(j,i,2);
            y2=Points(j,i+1,2);
            y3=Points(j+1,i,2);
            z1=Points(j,i,3);
            z2=Points(j,i+1,3);
            z3=Points(j+1,i,3);
        end
        xc=(x1+x2+x3)/3;
        yc=(y1+y2+y3)/3;
        zc=(z1+z2+z3)/3;
        coh=B_Cohesion(xc,yc,zc);
        phi=B_Friction(xc,yc,zc);
        r=sqrt((Yo-yc)^2+(Zo-zc)^2);
        bet=atan(-(zc-Zo)/(yc-Yo));
        if bet<0
            bet=bet+pi;
        end
        a=sqrt((y1-y2)^2+(z1-z2)^2);
        b=sqrt((y1-y3)^2+(z1-z3)^2);
        c=sqrt((y3-y2)^2+(z3-z2)^2);
        Wp=Wp+r*sin(bet)*B_Airetri(a,b,c)*abs(xc);
        a=sqrt((x1-x2)^2+(y1-y2)^2+(z1-z2)^2);
        b=sqrt((x1-x3)^2+(y1-y3)^2+(z1-z3)^2);
        c=sqrt((x3-x2)^2+(y3-y2)^2+(z3-z2)^2);
        Wr=Wr+cos(phi)*r*B_Airetri(a,b,c);
        if j/2==round(j/2)
            x1=Points(j+1,i,1);
            x2=Points(j+1,i+1,1);
            x3=Points(j,i,1);
            y1=Points(j+1,i,2);
            y2=Points(j+1,i+1,2);
            y3=Points(j,i,2);
            z1=Points(j+1,i,3);
            z2=Points(j+1,i+1,3);
            z3=Points(j,i,3);
        else
            x1=Points(j+1,i,1);
            x2=Points(j+1,i+1,1);
            x3=Points(j,i+1,1);
            y1=Points(j+1,i,2);
            y2=Points(j+1,i+1,2);
            y3=Points(j,i+1,2);
            z1=Points(j+1,i,3);
            z2=Points(j+1,i+1,3);
            z3=Points(j,i+1,3);
        end
        xc=(x1+x2+x3)/3;
        yc=(y1+y2+y3)/3;
        zc=(z1+z2+z3)/3;
        coh=B_Cohesion(xc,yc,zc);
        phi=B_Friction(xc,yc,zc);
        r=sqrt((Yo-yc)^2+(Zo-zc)^2);
        bet=atan(-(zc-Zo)/(yc-Yo));
        if bet<0
            bet=bet+pi;
        end
        a=sqrt((y1-y2)^2+(z1-z2)^2);
        b=sqrt((y1-y3)^2+(z1-z3)^2);
        c=sqrt((y3-y2)^2+(z3-z2)^2);
        if Coh>0
            d=abs((x1+x2)/2);
            rt=sqrt((Yo-(y1+y2)/2)^2+(Zo-(z1+z2)/2)^2);
            Wrt=Wrt+rt*a*d;
        end
        Wp=Wp+r*sin(bet)*B_Airetri(a,b,c)*abs(xc);
        a=sqrt((x1-x2)^2+(y1-y2)^2+(z1-z2)^2);
        b=sqrt((x1-x3)^2+(y1-y3)^2+(z1-z3)^2);
        c=sqrt((x3-x2)^2+(y3-y2)^2+(z3-z2)^2);
        Wr=Wr+cos(phi)*r*B_Airetri(a,b,c);
    end 
    Pow(j,1)=real(Wp);
    Pow(j,2)=real(Wr);
    Pow(j,3)=real(Wrt);
end
for j=1:size(Pow,1)
    Pow(j,4)=Pow(j,1)*Gam+Signe*Pow(j,2)*Coh;
    Pow(j,5)=sum(Pow(1:j,4))-Pow(j,3)*Rtrac;
end

Wt=0;
for i=1:Nteta-1
    x1=Contour(i,1);
    y1=Contour(i,2);
    x2=Contour(i+1,1);
    y2=Contour(i+1,2);
    h=(y1+y2)/2;
    r=sqrt((Yo-h)^2+Zo^2);
    bet=atan(Zo/(h-Yo));
    gr=1+Grad*(h+Diam/2);
    Wt=Wt+r*cos(bet)*gr*abs(x1+x2)/2*abs(y1-y2);
end

for j=j_A:size(Pow,1)
    if Pow(j,5)==max(-Signe*Pow(:,5))
        break
    end
end
jmax=j;

if Signe==-1 & Phi>0.1  %POUSSEE ET FROTTANT
    if Debouche==0        %NON DEBOUCHANT
        if Coh>0
            Nc=(sum(Pow(1:jmax,2))+Pow(jmax,3)*Rtrac/Coh)/Wt;
        else
            Nc=sum(Pow(1:jmax,2))/Wt;
        end
    else                %DEBOUCHANT
        Nc=sum(Pow(1:jmax,2))/Wt;
    end
    Ngamma=sum(Pow(1:jmax,1))/(Diam*Wt);
elseif Signe==1         %BUTEE
    Nc=(sum(Pow(:,2)))/Wt;
    Ngamma=sum(Pow(:,1))/(Diam*Wt);
elseif Phi<0.1          %PUREMENT COHERENT
    Nc=(sum(Pow(:,2)))/Wt;
    Ngamma=sum(Pow(:,1))/(Diam*Wt);
end
