function [Pf_MC,COV_MC]=A_FiabMC(F,Psis,MuSeuil,COVSeuil,LawSeuil,RuptSupInf,N_MC)

Nvar=size(Psis,2);
Npsi=size(Psis,1);
N_Rupt=0;
COV_MC=0;

if LawSeuil~=0
    [MuLog,SigLog]=A_Gauss_to_Log(MuSeuil,MuSeuil*COVSeuil/100);
end

for i=1:N_MC
    Seuil=randn;
    if LawSeuil==0
        Seuil=MuSeuil+MuSeuil*COVSeuil/100*Seuil;
    else
        Seuil=exp(MuLog+SigLog*Seuil);
    end
    
    Test=randn(1,Nvar);
    Output=0;
    for psi=1:Npsi
        valeurpsi=1;
        for var=1:Nvar
           if Psis(psi,var)==1
               valeurpsi=valeurpsi*Test(1,var);
           end
           if Psis(psi,var)==2
               valeurpsi=valeurpsi*(Test(1,var)^2-1);
           end
           if Psis(psi,var)==3
               valeurpsi=valeurpsi*(Test(1,var)^3-3*Test(1,var));
           end
           if Psis(psi,var)==4
               valeurpsi=valeurpsi*(Test(1,var)^4-6*Test(1,var)^2+3);
           end
            if Psis(psi,var)==5
                valeurpsi=valeurpsi*(Test(1,var)^5-10*Test(1,var)^3+15*Test(1,var));
            end
            if Psis(psi,var)==6
                valeurpsi=valeurpsi*(Test(1,var)^6-15*Test(1,var)^4+45*Test(1,var)^2-15);
            end
        end
        Output=Output+valeurpsi*F(psi);
    end
    Output=Output-Seuil;
    if Output*RuptSupInf>0
        N_Rupt=N_Rupt+1;
    end
end
Pf_MC=N_Rupt/N_MC;
if Pf_MC>0
    COV_MC=sqrt((1-Pf_MC)/(N_MC*Pf_MC));
else
    COV_MC=0;
end