function [Moments]=A_Moments_analytiques(F,Psis,Ordre)
Npsi=size(Psis,1);
Nvar=size(Psis,2);
Moments=zeros(1,4);
Moments(1,1)=F(1,1);
for j=2:Npsi
    Produit=1;
    for m=1:Nvar
        Produit=Produit*factorial(Psis(j,m));
    end
    Moments(1,2)=Moments(1,2)+Produit*F(j,1)^2;
end
for i=2:Npsi
    for j=2:Npsi
        for k=2:Npsi
            Produit=1;
            for m=1:Nvar
                Produit=Produit*A_Dijk(Psis(i,m),Psis(j,m),Psis(k,m));
            end
            Moments(1,3)=Moments(1,3)+Produit*F(i,1)*F(j,1)*F(k,1);
        end
    end
end
Moments(1,3)=Moments(1,3)/(Moments(1,2)^(3/2));
for i=2:Npsi
    for j=2:Npsi
        for k=2:Npsi
            for l=2:Npsi
                Produit=1;
                for m=1:Nvar
                    Dijkl=0;
                    for q=0:2*Ordre
                        Dijkl=Dijkl+A_Dijk(Psis(i,m),Psis(j,m),q)*A_Cijk(Psis(k,m),Psis(l,m),q);
                    end
                    Produit=Produit*Dijkl;
                end
                Moments(1,4)=Moments(1,4)+Produit*F(i,1)*F(j,1)*F(k,1)*F(l,1);
            end
        end
    end
end
Moments(1,4)=Moments(1,4)/(Moments(1,2)^2)-3;