%------------------PREMIER PLAN--------------------%
beta=Plans(1,7);
aax=0;
aay=cos(Plans(1,7));
aaz=-sin(Plans(1,7));
xv=0;
yv=Signe*sin(beta);
zv=Signe*cos(beta);
x1=Points(1,Nteta/2,1);
y1=Points(1,Nteta/2,2);
z1=Points(1,Nteta/2,3);
Teta1=Points(1,Nteta/2,4);
x2=Points(1,Nteta/2+1,1);
y2=Points(1,Nteta/2+1,2);
z2=Points(1,Nteta/2+1,3);
Teta2=Points(1,Nteta/2+1,4);
xprime=Xc;
yprime=Yc-Ly/2;
zprime=0;
Teta=(Teta1+Teta2)/2;
phi=B_Friction(xprime,yprime,zprime);
ax=-1;
ay=0;
az=0;
xc=Plans(2,3);
yc=Plans(2,4);
zc=Plans(2,5);
bx=xc-xprime;
by=yc-yprime;
bz=zc-zprime;
A=-zv/yv;
B=cos(pi/2+phi)/yv;
C=-A*ay/ax-az/ax;
D=(-B*ay)/ax;
E=1+C^2+A^2;
F=2*C*D+2*A*B;
G=D^2+B^2-1;
Delta=F^2-4*E*G;
zn=(-F+sqrt(Delta))/(2*E);
yn=A*zn+B;
xn=C*zn+D;
deltay=(zn*ax-xn*az);
deltaz=(xn*ay-yn*ax);
if Signe*(yv*deltay+zv*deltaz)>0
    zn=(-F-sqrt(Delta))/(2*E);
    yn=A*zn+B;
    xn=C*zn+D;
end
deltax=sin(Teta);
deltay=cos(Teta)*cos(Plans(2,7));
deltaz=-cos(Teta)*sin(Plans(2,7));
r=-(xn*bx+yn*by+zn*bz)/(deltax*xn+deltay*yn+deltaz*zn);
Points(2,Nteta/2,1)=xc+r*deltax;
Points(2,Nteta/2,2)=yc+r*deltay;
Points(2,Nteta/2,3)=zc+r*deltaz;
Points(2,Nteta/2,4)=Teta;
Points(2,Nteta/2,5)=deltax;
Points(2,Nteta/2,6)=deltay;
Points(2,Nteta/2,7)=deltaz;
Points(2,Nteta/2,8)=r;

Points(2,Nteta/2-1,1)=Contour(Nteta/2-1,1);
Points(2,Nteta/2-1,2)=Contour(Nteta/2-1,2);
bbx=Points(2,Nteta/2-1,1)-Plans(2,3);
bby=Points(2,Nteta/2-1,2)-Plans(2,4);
bbz=Points(2,Nteta/2-1,3)-Plans(2,5);
bb=sqrt(bbx^2+bby^2+bbz^2);
Points(2,Nteta/2-1,4)=acos((aax*bbx+aay*bby+aaz*bbz)/bb);
Points(2,Nteta/2-1,8)=sqrt((Points(2,Nteta/2-1,3)-Zo)^2+(Points(2,Nteta/2-1,2)-Yo)^2);
        
Points(2,Nteta/2+1,1)=Contour(Nteta/2+2,1);
Points(2,Nteta/2+1,2)=Contour(Nteta/2+2,2);
bbx=Points(2,Nteta/2+1,1)-Plans(2,3);
bby=Points(2,Nteta/2+1,2)-Plans(2,4);
bbz=Points(2,Nteta/2+1,3)-Plans(2,5);
bb=sqrt(bbx^2+bby^2+bbz^2);
Points(2,Nteta/2+1,4)=2*pi-acos((aax*bbx+aay*bby+aaz*bbz)/bb);
Points(2,Nteta/2+1,8)=sqrt((Points(2,Nteta/2+1,3)-Zo)^2+(Points(2,Nteta/2+1,2)-Yo)^2);




%------------------DEUXIEME PLAN--------------------%
beta=Plans(2,7);
aax=0;
aay=cos(Plans(2,7));
aaz=-sin(Plans(2,7));
xv=0;
yv=Signe*sin(beta);
zv=Signe*cos(beta);
x1=Points(2,Nteta/2-1,1);
y1=Points(2,Nteta/2-1,2);
z1=Points(2,Nteta/2-1,3);
Teta1=Points(2,Nteta/2-1,4);
x2=Points(2,Nteta/2,1);
y2=Points(2,Nteta/2,2);
z2=Points(2,Nteta/2,3);
Teta2=Points(2,Nteta/2,4);
x3=Points(2,Nteta/2+1,1);
y3=Points(2,Nteta/2+1,2);
z3=Points(2,Nteta/2+1,3);
Teta3=Points(2,Nteta/2+1,4);
Coefs=[Teta1^2,Teta1,1;Teta2^2,Teta2,1;Teta3^2,Teta3,1]^-1*[sqrt((xc-x1)^2+(yc-y1)^2+(zc-z1)^2);sqrt((xc-x2)^2+(yc-y2)^2+(zc-z2)^2);sqrt((xc-x3)^2+(yc-y3)^2+(zc-z3)^2)];

xc=Plans(2,3);
yc=Plans(2,4);
zc=Plans(2,5);
Teta=(Teta1+Teta2)/2;
Rprime=Coefs(1)*Teta^2+Coefs(2)*Teta+Coefs(3);
xprime=xc+Rprime*sin(Teta);
yprime=yc+Rprime*cos(Teta)*cos(Plans(3,7));
zprime=zc-Rprime*cos(Teta)*sin(Plans(3,7));
phi=B_Friction(xprime,yprime,zprime);
deriv=((2*Coefs(1)*Teta+Coefs(2))*cos(Teta)-(Coefs(1)*Teta^2+Coefs(2)*Teta+Coefs(3))*sin(Teta))/(-(2*Coefs(1)*Teta+Coefs(2))*sin(Teta)-(Coefs(1)*Teta^2+Coefs(2)*Teta+Coefs(3))*cos(Teta));
ax=-1;
ay=-cos(Plans(2,7))*deriv;
az=sin(Plans(2,7))*deriv;
xc=Plans(3,3);
yc=Plans(3,4);
zc=Plans(3,5);
bx=xc-xprime;
by=yc-yprime;
bz=zc-zprime;
A=-zv/yv;
B=cos(pi/2+phi)/yv;
C=-A*ay/ax-az/ax;
D=(-B*ay)/ax;
E=1+C^2+A^2;
F=2*C*D+2*A*B;
G=D^2+B^2-1;
Delta=F^2-4*E*G;
zn=(-F+sqrt(Delta))/(2*E);
yn=A*zn+B;
xn=C*zn+D;
deltay=(zn*ax-xn*az);
deltaz=(xn*ay-yn*ax);
if Signe*(yv*deltay+zv*deltaz)>0
    zn=(-F-sqrt(Delta))/(2*E);
    yn=A*zn+B;
    xn=C*zn+D;
end
deltax=sin(Teta);
deltay=cos(Teta)*cos(Plans(3,7));
deltaz=-cos(Teta)*sin(Plans(3,7));
r=-(xn*bx+yn*by+zn*bz)/(deltax*xn+deltay*yn+deltaz*zn);
Points(3,Nteta/2,1)=xc+r*deltax;
Points(3,Nteta/2,2)=yc+r*deltay;
Points(3,Nteta/2,3)=zc+r*deltaz;
Points(3,Nteta/2,4)=Teta;
Points(3,Nteta/2,5)=deltax;
Points(3,Nteta/2,6)=deltay;
Points(3,Nteta/2,7)=deltaz;
Points(3,Nteta/2,8)=r;

xc=Plans(2,3);
yc=Plans(2,4);
zc=Plans(2,5);
Teta=(Teta2+Teta3)/2;
Rprime=Coefs(1)*Teta^2+Coefs(2)*Teta+Coefs(3);
xprime=xc+Rprime*sin(Teta);
yprime=yc+Rprime*cos(Teta)*cos(Plans(3,7));
zprime=zc-Rprime*cos(Teta)*sin(Plans(3,7));
phi=B_Friction(xprime,yprime,zprime);
deriv=((2*Coefs(1)*Teta+Coefs(2))*cos(Teta)-(Coefs(1)*Teta^2+Coefs(2)*Teta+Coefs(3))*sin(Teta))/(-(2*Coefs(1)*Teta+Coefs(2))*sin(Teta)-(Coefs(1)*Teta^2+Coefs(2)*Teta+Coefs(3))*cos(Teta));
ax=-1;
ay=-cos(Plans(2,7))*deriv;
az=sin(Plans(2,7))*deriv;
xc=Plans(3,3);
yc=Plans(3,4);
zc=Plans(3,5);
bx=xc-xprime;
by=yc-yprime;
bz=zc-zprime;
A=-zv/yv;
B=cos(pi/2+phi)/yv;
C=-A*ay/ax-az/ax;
D=(-B*ay)/ax;
E=1+C^2+A^2;
F=2*C*D+2*A*B;
G=D^2+B^2-1;
Delta=F^2-4*E*G;
zn=(-F+sqrt(Delta))/(2*E);
yn=A*zn+B;
xn=C*zn+D;
deltay=(zn*ax-xn*az);
deltaz=(xn*ay-yn*ax);
if Signe*(yv*deltay+zv*deltaz)>0
    zn=(-F-sqrt(Delta))/(2*E);
    yn=A*zn+B;
    xn=C*zn+D;
end
deltax=sin(Teta);
deltay=cos(Teta)*cos(Plans(3,7));
deltaz=-cos(Teta)*sin(Plans(3,7));
r=-(xn*bx+yn*by+zn*bz)/(deltax*xn+deltay*yn+deltaz*zn);
Points(3,Nteta/2+1,1)=xc+r*deltax;
Points(3,Nteta/2+1,2)=yc+r*deltay;
Points(3,Nteta/2+1,3)=zc+r*deltaz;
Points(3,Nteta/2+1,4)=Teta;
Points(3,Nteta/2+1,5)=deltax;
Points(3,Nteta/2+1,6)=deltay;
Points(3,Nteta/2+1,7)=deltaz;
Points(3,Nteta/2+1,8)=r;

Points(3,Nteta/2-1,1)=Contour(Nteta/2-2,1);
Points(3,Nteta/2-1,2)=Contour(Nteta/2-2,2);
bbx=Points(3,Nteta/2-1,1)-Plans(3,3);
bby=Points(3,Nteta/2-1,2)-Plans(3,4);
bbz=Points(3,Nteta/2-1,3)-Plans(3,5);
bb=sqrt(bbx^2+bby^2+bbz^2);
Points(3,Nteta/2-1,4)=acos((aax*bbx+aay*bby+aaz*bbz)/bb);
Points(3,Nteta/2-1,8)=sqrt((Points(3,Nteta/2-1,3)-Zo)^2+(Points(3,Nteta/2-1,2)-Yo)^2);
        
Points(3,Nteta/2+2,1)=Contour(Nteta/2+3,1);
Points(3,Nteta/2+2,2)=Contour(Nteta/2+3,2);
bbx=Points(3,Nteta/2+2,1)-Plans(3,3);
bby=Points(3,Nteta/2+2,2)-Plans(3,4);
bbz=Points(3,Nteta/2+2,3)-Plans(3,5);
bb=sqrt(bbx^2+bby^2+bbz^2);
Points(3,Nteta/2+2,4)=2*pi-acos((aax*bbx+aay*bby+aaz*bbz)/bb);
Points(3,Nteta/2+2,8)=sqrt((Points(3,Nteta/2+2,3)-Zo)^2+(Points(3,Nteta/2+2,2)-Yo)^2);



%------------------PLANS DE 3 A J_A-1--------------------%
for j=3:j_A-1
    beta=Plans(j,7);
    sinbeta=sin(beta);
    cosbeta=cos(beta);
    betap=Plans(j+1,7);
    sinbetap=sin(Plans(j+1,7));
    cosbetap=cos(Plans(j+1,7));
    xv=0;
    yv=Signe*sinbeta;
    zv=Signe*cosbeta;
    aax=0;
    aay=cosbeta;
    aaz=-sinbeta;
    if j/2==round(j/2)
        dep=Nteta/2-j/2;
        fin=Nteta/2+(j-2)/2;
    else
        dep=Nteta/2-(j-1)/2;
        fin=Nteta/2+(j-1)/2;
    end
    A=-zv/yv;
    B=cos(pi/2+phi)/yv;
    for i=dep:fin
        xc=Plans(j,3);
        yc=Plans(j,4);
        zc=Plans(j,5);
        if i==dep
            x1=Points(j,i,1);
            x2=Points(j,i+1,1);
            x3=Points(j,i+2,1);
            x4=Points(j,i+3,1);
            y1=Points(j,i,2);
            y2=Points(j,i+1,2);
            y3=Points(j,i+2,2);
            y4=Points(j,i+3,2);
            z1=Points(j,i,3);
            z2=Points(j,i+1,3);
            z3=Points(j,i+2,3);
            z4=Points(j,i+3,3);
            Teta1=Points(j,i,4);
            Teta2=Points(j,i+1,4);
            Teta3=Points(j,i+2,4);
            Teta4=Points(j,i+3,4);
            xprime=(x1+x2)/2;
            yprime=(y1+y2)/2;
            zprime=(z1+z2)/2;
            phi=B_Friction(xprime,yprime,zprime);
            ax=x2-x1;
            ay=y2-y1;
            az=z2-z1;
            Teta=(Teta2+Teta1)/2;
            costeta=cos(Teta);
            sinteta=sin(Teta);
        elseif i==fin
            x1=Points(j,i-2,1);
            x2=Points(j,i-1,1);
            x3=Points(j,i,1);
            x4=Points(j,i+1,1);
            y1=Points(j,i-2,2);
            y2=Points(j,i-1,2);
            y3=Points(j,i,2);
            y4=Points(j,i+1,2);
            z1=Points(j,i-2,3);
            z2=Points(j,i-1,3);
            z3=Points(j,i,3);
            z4=Points(j,i+1,3);
            Teta1=Points(j,i-2,4);
            Teta2=Points(j,i-1,4);
            Teta3=Points(j,i,4);
            Teta4=Points(j,i+1,4);
            xprime=(x3+x4)/2;
            yprime=(y3+y4)/2;
            zprime=(z3+z4)/2;
            phi=B_Friction(xprime,yprime,zprime);
            ax=x4-x3;
            ay=y4-y3;
            az=z4-z3;
            Teta=(Teta4+Teta3)/2;
            costeta=cos(Teta);
            sinteta=sin(Teta);
        else
            x1=Points(j,i-1,1);
            x2=Points(j,i,1);
            x3=Points(j,i+1,1);
            x4=Points(j,i+2,1);
            y1=Points(j,i-1,2);
            y2=Points(j,i,2);
            y3=Points(j,i+1,2);
            y4=Points(j,i+2,2);
            z1=Points(j,i-1,3);
            z2=Points(j,i,3);
            z3=Points(j,i+1,3);
            z4=Points(j,i+2,3);
            Teta1=Points(j,i-1,4);
            Teta2=Points(j,i,4);
            Teta3=Points(j,i+1,4);
            Teta4=Points(j,i+2,4);
            xprime=(x3+x2)/2;
            yprime=(y3+y2)/2;
            zprime=(z3+z2)/2;
            phi=B_Friction(xprime,yprime,zprime);
            ax=x3-x2;
            ay=y3-y2;
            az=z3-z2;
            Teta=(Teta2+Teta3)/2;
            costeta=cos(Teta);
            sinteta=sin(Teta);
        end
        xc=Plans(j+1,3);
        yc=Plans(j+1,4);
        zc=Plans(j+1,5);
        bx=xc-xprime;
        by=yc-yprime;
        bz=zc-zprime;
        C=-A*ay/ax-az/ax;
        D=(-B*ay)/ax;
        E=1+C^2+A^2;
        F=2*C*D+2*A*B;
        G=D^2+B^2-1;
        Delta=F^2-4*E*G;
        zn=(-F+sqrt(Delta))/(2*E);
        yn=A*zn+B;
        xn=C*zn+D;
        deltay=(zn*ax-xn*az);
        deltaz=(xn*ay-yn*ax);
        if Signe*(yv*deltay+zv*deltaz)>0
            zn=(-F-sqrt(Delta))/(2*E);
            yn=A*zn+B;
            xn=C*zn+D;
        end
        deltax=sinteta;
        deltay=costeta*cosbetap;
        deltaz=-costeta*sinbetap;
        r=-(xn*bx+yn*by+zn*bz)/(deltax*xn+deltay*yn+deltaz*zn);
        if j/2==round(j/2)
            Points(j+1,i+1,1)=xc+r*deltax;
            Points(j+1,i+1,2)=yc+r*deltay;
            Points(j+1,i+1,3)=zc+r*deltaz;
            Points(j+1,i+1,4)=Teta;
            Points(j+1,i+1,5)=deltax;
            Points(j+1,i+1,6)=deltay;
            Points(j+1,i+1,7)=deltaz;
            Points(j+1,i+1,8)=r;
        else
            Points(j+1,i,1)=xc+r*deltax;
            Points(j+1,i,2)=yc+r*deltay;
            Points(j+1,i,3)=zc+r*deltaz;
            Points(j+1,i,4)=Teta;
            Points(j+1,i,5)=xprime;
            Points(j+1,i,6)=yprime;
            Points(j+1,i,7)=zprime;
            Points(j+1,i,8)=r;
        end
    end

    if j/2==round(j/2)
        Points(j+1,Nteta/2-j/2,1)=Contour(Nteta/2-j,1);
        Points(j+1,Nteta/2-j/2,2)=Contour(Nteta/2-j,2);
        bbx=Points(j+1,Nteta/2-j/2,1)-Plans(j+1,3);
        bby=Points(j+1,Nteta/2-j/2,2)-Plans(j+1,4);
        bbz=Points(j+1,Nteta/2-j/2,3)-Plans(j+1,5);
        bb=sqrt(bbx^2+bby^2+bbz^2);
        Points(j+1,Nteta/2-j/2,4)=acos((aax*bbx+aay*bby+aaz*bbz)/bb);
        Points(j+1,Nteta/2-j/2,8)=sqrt((Points(j+1,Nteta/2-j/2,3)-Zo)^2+(Points(j+1,Nteta/2-j/2,2)-Yo)^2);
        
        Points(j+1,Nteta/2+j/2+1,1)=Contour(Nteta/2+j+1,1);
        Points(j+1,Nteta/2+j/2+1,2)=Contour(Nteta/2+j+1,2);
        bbx=Points(j+1,Nteta/2+j/2+1,1)-Plans(j+1,3);
        bby=Points(j+1,Nteta/2+j/2+1,2)-Plans(j+1,4);
        bbz=Points(j+1,Nteta/2+j/2+1,3)-Plans(j+1,5);
        bb=sqrt(bbx^2+bby^2+bbz^2);
        Points(j+1,Nteta/2+j/2+1,4)=2*pi-acos((aax*bbx+aay*bby+aaz*bbz)/bb);
        Points(j+1,Nteta/2+j/2+1,8)=sqrt((Points(j+1,Nteta/2+j/2+1,3)-Zo)^2+(Points(j+1,Nteta/2+j/2+1,2)-Yo)^2);
    else
        Points(j+1,Nteta/2-(j+1)/2,1)=Contour(Nteta/2-j,1);
        Points(j+1,Nteta/2-(j+1)/2,2)=Contour(Nteta/2-j,2);
        bbx=Points(j+1,Nteta/2-(j+1)/2,1)-Plans(j+1,3);
        bby=Points(j+1,Nteta/2-(j+1)/2,2)-Plans(j+1,4);
        bbz=Points(j+1,Nteta/2-(j+1)/2,3)-Plans(j+1,5);
        bb=sqrt(bbx^2+bby^2+bbz^2);
        Points(j+1,Nteta/2-(j+1)/2,4)=acos((aax*bbx+aay*bby+aaz*bbz)/bb);
        Points(j+1,Nteta/2-(j+1)/2,8)=sqrt((Points(j+1,Nteta/2-(j+1)/2,3)-Zo)^2+(Points(j+1,Nteta/2-(j+1)/2,2)-Yo)^2);
        
        Points(j+1,Nteta/2+(j+1)/2,1)=Contour(Nteta/2+j+1,1);
        Points(j+1,Nteta/2+(j+1)/2,2)=Contour(Nteta/2+j+1,2);
        bbx=Points(j+1,Nteta/2+(j+1)/2,1)-Plans(j+1,3);
        bby=Points(j+1,Nteta/2+(j+1)/2,2)-Plans(j+1,4);
        bbz=Points(j+1,Nteta/2+(j+1)/2,3)-Plans(j+1,5);
        bb=sqrt(bbx^2+bby^2+bbz^2);
        Points(j+1,Nteta/2+(j+1)/2,4)=2*pi-acos((aax*bbx+aay*bby+aaz*bbz)/bb);
        Points(j+1,Nteta/2+(j+1)/2,8)=sqrt((Points(j+1,Nteta/2+(j+1)/2,3)-Zo)^2+(Points(j+1,Nteta/2+(j+1)/2,2)-Yo)^2);
    end
end



%------------------PLANS DE J_A A J_F-1--------------------%
for j=j_A:j_F-1
    beta=Plans(j,7);
    sinbeta=sin(beta);
    cosbeta=cos(beta);
    betap=Plans(j+1,7);
    sinbetap=sin(betap);
    cosbetap=cos(betap);
    xv=0;
    yv=Signe*sinbeta;
    zv=Signe*cosbeta;
    aax=0;
    aay=cosbeta;
    aaz=-sinbeta;
    A=-zv/yv;
    B=cos(pi/2+phi)/yv;
    dep=Nteta/4;
    fin=3*Nteta/4;
    for i=dep:fin
        xc=Plans(j,3);
        yc=Plans(j,4);
        zc=Plans(j,5);
        if j/2==round(j/2)
            if i==dep
                x1=Points(j,fin-1,1);
                x2=Points(j,fin,1);
                x3=Points(j,i,1);
                x4=Points(j,i+1,1);
                y1=Points(j,fin-1,2);
                y2=Points(j,fin,2);
                y3=Points(j,i,2);
                y4=Points(j,i+1,2);
                z1=Points(j,fin-1,3);
                z2=Points(j,fin,3);
                z3=Points(j,i,3);
                z4=Points(j,i+1,3);
                Teta1=Points(j,fin-1,4)-2*pi;
                Teta2=Points(j,fin,4)-2*pi;
                Teta3=Points(j,i,4);
                Teta4=Points(j,i+1,4);
            elseif i==dep+1
                x1=Points(j,fin,1);
                x2=Points(j,i-1,1);
                x3=Points(j,i,1);
                x4=Points(j,i+1,1);
                y1=Points(j,fin,2);
                y2=Points(j,i-1,2);
                y3=Points(j,i,2);
                y4=Points(j,i+1,2);
                z1=Points(j,fin,3);
                z2=Points(j,i-1,3);
                z3=Points(j,i,3);
                z4=Points(j,i+1,3);
                Teta1=Points(j,fin,4)-2*pi;
                Teta2=Points(j,i-1,4);
                Teta3=Points(j,i,4);
                Teta4=Points(j,i+1,4);
            elseif i==fin
                x1=Points(j,i-2,1);
                x2=Points(j,i-1,1);
                x3=Points(j,i,1);
                x4=Points(j,dep,1);
                y1=Points(j,i-2,2);
                y2=Points(j,i-1,2);
                y3=Points(j,i,2);
                y4=Points(j,dep,2);
                z1=Points(j,i-2,3);
                z2=Points(j,i-1,3);
                z3=Points(j,i,3);
                z4=Points(j,dep,3);
                Teta1=Points(j,i-2,4);
                Teta2=Points(j,i-1,4);
                Teta3=Points(j,i,4);
                Teta4=Points(j,dep,4)+2*pi;
            else
                x1=Points(j,i-2,1);
                x2=Points(j,i-1,1);
                x3=Points(j,i,1);
                x4=Points(j,i+1,1);
                y1=Points(j,i-2,2);
                y2=Points(j,i-1,2);
                y3=Points(j,i,2);
                y4=Points(j,i+1,2);
                z1=Points(j,i-2,3);
                z2=Points(j,i-1,3);
                z3=Points(j,i,3);
                z4=Points(j,i+1,3);
                Teta1=Points(j,i-2,4);
                Teta2=Points(j,i-1,4);
                Teta3=Points(j,i,4);
                Teta4=Points(j,i+1,4);
            end
        else
            if i==dep
                x1=Points(j,fin,1);
                x2=Points(j,i,1);
                x3=Points(j,i+1,1);
                x4=Points(j,i+2,1);
                y1=Points(j,fin,2);
                y2=Points(j,i,2);
                y3=Points(j,i+1,2);
                y4=Points(j,i+2,2);
                z1=Points(j,fin,3);
                z2=Points(j,i,3);
                z3=Points(j,i+1,3);
                z4=Points(j,i+2,3);
                Teta1=Points(j,fin,4)-2*pi;
                Teta2=Points(j,i,4);
                Teta3=Points(j,i+1,4);
                Teta4=Points(j,i+2,4);
            elseif i==fin-1
                x1=Points(j,i-1,1);
                x2=Points(j,i,1);
                x3=Points(j,i+1,1);
                x4=Points(j,dep,1);
                y1=Points(j,i-1,2);
                y2=Points(j,i,2);
                y3=Points(j,i+1,2);
                y4=Points(j,dep,2);
                z1=Points(j,i-1,3);
                z2=Points(j,i,3);
                z3=Points(j,i+1,3);
                z4=Points(j,dep,3);
                Teta1=Points(j,i-1,4);
                Teta2=Points(j,i,4);
                Teta3=Points(j,i+1,4);
                Teta4=Points(j,dep,4)+2*pi;
            elseif i==fin
                x1=Points(j,i-1,1);
                x2=Points(j,i,1);
                x3=Points(j,dep,1);
                x4=Points(j,dep+1,1);
                y1=Points(j,i-1,2);
                y2=Points(j,i,2);
                y3=Points(j,dep,2);
                y4=Points(j,dep+1,2);
                z1=Points(j,i-1,3);
                z2=Points(j,i,3);
                z3=Points(j,dep,3);
                z4=Points(j,dep+1,3);
                Teta1=Points(j,i-1,4);
                Teta2=Points(j,i,4);
                Teta3=Points(j,dep,4)+2*pi;
                Teta4=Points(j,dep+1,4)+2*pi;
            else
                x1=Points(j,i-1,1);
                x2=Points(j,i,1);
                x3=Points(j,i+1,1);
                x4=Points(j,i+2,1);
                y1=Points(j,i-1,2);
                y2=Points(j,i,2);
                y3=Points(j,i+1,2);
                y4=Points(j,i+2,2);
                z1=Points(j,i-1,3);
                z2=Points(j,i,3);
                z3=Points(j,i+1,3);
                z4=Points(j,i+2,3);
                Teta1=Points(j,i-1,4);
                Teta2=Points(j,i,4);
                Teta3=Points(j,i+1,4);
                Teta4=Points(j,i+2,4);
            end
        end
        Teta=(Teta2+Teta3)/2;
        sinteta=sin(Teta);
        costeta=cos(Teta);
        xprime=(x2+x3)/2;
        yprime=(y2+y3)/2;
        zprime=(z2+z3)/2;
        phi=B_Friction(xprime,yprime,zprime);
        ax=x3-x2;
        ay=y3-y2;
        az=z3-z2;
        xc=Plans(j+1,3);
        yc=Plans(j+1,4);
        zc=Plans(j+1,5);
        bx=xc-xprime;
        by=yc-yprime;
        bz=zc-zprime;
        C=-A*ay/ax-az/ax;
        D=(-B*ay)/ax;
        E=1+C^2+A^2;
        F=2*C*D+2*A*B;
        G=D^2+B^2-1;
        Delta=F^2-4*E*G;
        zn=(-F+sqrt(Delta))/(2*E);
        yn=A*zn+B;
        xn=C*zn+D;
        if Signe*(yv*(zn*ax-xn*az)+zv*(xn*ay-yn*ax))>0
            zn=(-F-sqrt(Delta))/(2*E);
            yn=A*zn+B;
            xn=C*zn+D;
        end
        deltax=sinteta;
        deltay=costeta*cosbeta;
        deltaz=-costeta*sinbeta;
        r=-(xn*bx+yn*by+zn*bz)/(deltax*xn+deltay*yn+deltaz*zn);
        Points(j+1,i,1)=xc+r*deltax;
        Points(j+1,i,2)=yc+r*deltay;
        Points(j+1,i,3)=zc+r*deltaz;
        Points(j+1,i,4)=Teta;
        Points(j+1,i,5)=xprime;
        Points(j+1,i,6)=yprime;
        Points(j+1,i,7)=zprime;
        Points(j+1,i,8)=r;
    end
    if min(Points(j+1,Nteta/4:3*Nteta/4,8))<0
        break
    end
end
Points=Points(1:j+1,:,:);




%------------------INTERSECTION SURFACE--------------------%
Debouche=0;
for i=Nteta/4:3*Nteta/4
    for j=j_A+1:size(Points,1)
        if Points(j,i,2)>Couv
            Debouche=1;
            Points(j,i,1:3)=Points(j,i,5:7)+(Points(j,i,1:3)-Points(j,i,5:7))/(Points(j,i,2)-Points(j,i,6))*(Couv-Points(j,i,6));
            if j<size(Points,1)
                for jj=j+1:size(Points,1)
                    Points(jj,i,1:3)=Points(j,i,1:3);
                end
            end
            break
        end
    end
end

Points=cat(2,Points,zeros(size(Points,1),1,8));
Points(:,Nteta+1,:)=Points(:,1,:);