load('INPUT.mat')

Signe=Input_Data(1,1);
Diam=Input_Data(1,2);
Couv=Input_Data(1,3);
Qsurf=Input_Data(1,4);
Phi=Input_Data(1,5);
Coh=Input_Data(1,6);
Gam=Input_Data(1,7);
Nteta=Input_Data(1,8);
Delta_Beta=Input_Data(1,9);

Rtrac=Coh/tan(Phi/180*pi);   %Coh/tan(Phi/180*pi) ou 0 ou Coh ou n'importe quelle autre valeur de rsistance  la traction
Grad=0;
BetaC=Parameters(1)/180*pi;
RC=Parameters(2);
Xc=0;
Yc=-Diam/2;
Lx=Diam;
Ly=Diam;

Yo=RC*cos(BetaC)+Yc;
Zo=-RC*sin(BetaC);
BetaA=atan(-Zo/(Yo-Yc-Ly/2));
RA=sqrt(Zo^2+(Yo-Yc-Ly/2)^2);
BetaB=atan(-Zo/(Yo-Yc+Ly/2));
RB=sqrt(Zo^2+(Yo-Yc+Ly/2)^2);
BetaE=-Signe*0.5*(log(RB/RA)/tan(Phi/180*pi)-Signe*(BetaA+BetaB));
RE=RA*exp(Signe*(BetaA-BetaE)*tan(Phi/180*pi));
j_A=Nteta/2;
if Phi>0.1
    if Signe==-1
        if Yo+RE*sin(BetaE-pi/2)<Couv
            BetaF=BetaE;
        else
            if Yo>Couv
                cas=2;
                BetaF=fminsearch(@B_Fonct_Param,BetaA);
            else
                cas=1;
                BetaF=fminsearch(@B_Fonct_Param,BetaA);
            end
        end
    elseif Signe==1
        cas=3;
        BetaF1=fminsearch(@B_Fonct_Param,BetaA);
        cas=4;
        BetaF2=fminsearch(@B_Fonct_Param,BetaA);
        BetaF=max([BetaF1,BetaF2]);
    end
else
    cas=3;
    BetaF1=fminsearch(@B_Fonct_Param,BetaA);
    cas=4;
    BetaF2=fminsearch(@B_Fonct_Param,BetaA);
    BetaF=max([BetaF1,BetaF2]);
end
Delta_Beta=(BetaF-BetaA)/round((BetaF-BetaA)/(Delta_Beta/180*pi));
j_F=j_A+(BetaF-BetaA)/Delta_Beta;
Sortie=0;
if Signe==1
    j_F=j_F+2;
end

Angles=zeros(1,Nteta);
for i=1:Nteta
    Angles(1,i)=2*pi/Nteta*(i-0.5);
end

Contour=zeros(Nteta,5);
for i=1:Nteta
    Contour(i,3)=sin(Angles(1,i));
    Contour(i,4)=cos(Angles(1,i));
    Contour(i,5)=sqrt((Lx^2*Ly^2)/(Lx^2*cos(Angles(1,i))^2+Ly^2*sin(Angles(1,i))^2))/2;
    Contour(i,1)=Xc+Contour(i,3)*Contour(i,5);
    Contour(i,2)=Yc+Contour(i,4)*Contour(i,5);
end

Plans=zeros(j_F,12);
for j=1:j_A
    Plans(j,2)=Contour(j_A+j,2);
    Plans(j,1)=(Yo-Plans(j,2))/Zo;
    Plans(j,7)=atan(Plans(j,1))+pi/2;
    Plans(j,4)=Yo-RE*cos(Plans(j,7));
    Plans(j,5)=Zo+RE*sin(Plans(j,7));
end
for j=j_A+1:j_F
    Plans(j,7)=Plans(j-1,7)+Delta_Beta;
    Plans(j,4)=Yo-RE*cos(Plans(j,7));
    Plans(j,5)=Zo+RE*sin(Plans(j,7));
    Plans(j,1)=tan(Plans(j,7)-pi/2);
    Plans(j,2)=Yo-Zo*Plans(j,1);
end

for j=1:j_F
    bet=Plans(j,7);
    r1=RE*exp((bet-BetaE)*tan(Phi/180*pi));
    r2=RE*exp((BetaE-bet)*tan(Phi/180*pi));
    extr(j,2)=Yo-r1*cos(bet);
    extr(j,3)=Zo+r1*sin(bet);
    extr(j,5)=Yo-r2*cos(bet);
    extr(j,6)=Zo+r2*sin(bet);
end

Points=zeros(1,Nteta,8);
Points(1,Nteta/2,1)=Contour(Nteta/2,1);
Points(1,Nteta/2,2)=Contour(Nteta/2,2);
aax=0;
aay=cos(Plans(1,7));
aaz=-sin(Plans(1,7));
bbx=Points(1,Nteta/2,1)-Plans(1,3);
bby=Points(1,Nteta/2,2)-Plans(1,4);
bbz=Points(1,Nteta/2,3)-Plans(1,5);
bb=sqrt(bbx^2+bby^2+bbz^2);
Points(1,Nteta/2,4)=acos((aax*bbx+aay*bby+aaz*bbz)/bb);
Points(1,Nteta/2,8)=sqrt((Points(1,Nteta/2,3)-Zo)^2+(Points(1,Nteta/2,2)-Yo)^2);
Points(1,Nteta/2+1,1)=Contour(Nteta/2+1,1);
Points(1,Nteta/2+1,2)=Contour(Nteta/2+1,2);
bbx=Points(1,Nteta/2+1,1)-Plans(1,3);
bby=Points(1,Nteta/2+1,2)-Plans(1,4);
bbz=Points(1,Nteta/2+1,3)-Plans(1,5);
bb=sqrt(bbx^2+bby^2+bbz^2);
Points(1,Nteta/2+1,4)=2*pi-acos((aax*bbx+aay*bby+aaz*bbz)/bb);
Points(1,Nteta/2+1,8)=sqrt((Points(1,Nteta/2+1,3)-Zo)^2+(Points(1,Nteta/2+1,2)-Yo)^2);